# norootforbuild

%define sgi_chroot_build 0
%define sgi_issp_build 0

Name: pcp
Version: 2.7.4
Release: 20080507
Distribution: redhat
Packager: Silicon Graphics, Inc. <http://www.sgi.com/>
BuildRoot: /tmp/pcp-build-4275 
BuildRequires: gcc-c++ libstdc++-devel procps autoconf bison flex ncurses-devel

%if %sgi_chroot_build
Source: pcp-2.7.4.tar.bz2
#
# Try not building 32bit libs for x86_64 & see who screams 
#%ifarch x86_64
#BuildRequires: glibc-devel-32bit
#%endif
%else
Source: pcp-2.7.4-20080507.src.tar.gz
%endif

Conflicts: pcp-pro < 2.2
Provides: pcp-open = 2.7.4

# Stuff used indirectly e.g. by shell scripts we install
Requires: bash gawk sed grep fileutils findutils cpp

# RPMs supplying "direct" requirements
Requires: glibc libgcc libstdc++
%ifarch ia64
Requires: libunwind
%endif

%if %sgi_chroot_build
Obsoletes: pcp <= 2.7.4
Provides: pcp = 2.7.4
%endif

Provides: libpcp.so.2
%ifarch ia64 x86_64
Provides: libpcp.so.2()(64bit)
%endif

Provides: libpcp_pmda.so.2
%ifarch ia64 x86_64
Provides: libpcp_pmda.so.2()(64bit)
%endif

Summary: System-level performance monitoring and performance management. 
License: GPL/LGPL
Vendor: Silicon Graphics, Inc.
URL: http://oss.sgi.com/projects/pcp
Group: Applications/System

%description
Performance Co-Pilot (PCP) is a framework and services to
support system-level performance monitoring and performance
management. 

The PCP open source release provides a unifying abstraction for
all of the interesting performance data in a system, and allows
client applications to easily retrieve and process any subset of
that data. 

%if %sgi_chroot_build
%debug_package
%endif

# In .census is exist, then no setup is necessary, just go and do the build,
# otherwise run setup
%prep
if [ -f .census ] ; then
   if [ ! -d ${RPM_PACKAGE_NAME}-${RPM_PACKAGE_VERSION} ] ; then
      ln -s . ${RPM_PACKAGE_NAME}-${RPM_PACKAGE_VERSION}
   fi
else
%setup
touch .census
autoconf
./configure
fi
%if %sgi_issp_build
%{_sgi_find_crypto}
%endif


%clean
[ ! -z "$DIST_ROOT" ] && rm -rf $DIST_ROOT

%build
/usr/bin/gmake default_pcp

%install
BACKDIR=`pwd`;
DIST_ROOT=$RPM_BUILD_ROOT
DIST_MANIFEST=`pwd`/install.manifest
export DIST_ROOT DIST_MANIFEST
rm -f $DIST_MANIFEST
/usr/bin/gmake install_pcp

set +x
PCP_CONF=$BACKDIR/src/include/pcp.conf
export PCP_CONF
. $BACKDIR/src/include/pcp.env
sort $DIST_MANIFEST | uniq | $PCP_AWK_PROG ' 
$1 == "d" { printf ("%%%%dir %%%%attr(%s,root,root) %s\n", $2, $5); } 
$1 == "f" { if ( match ($6, "'$PCP_VAR_DIR'/config") ||
		 match ($6, "'$PCP_SYSCONFIG_DIR'") ) {
	       printf ("%%%%config ");
	    }
	    if (match ($6, "'$PCP_MAN_DIR'") || match ($6, "'$PCP_DOC_DIR'")) {
		printf ("%%%%doc ");
	    }
	    printf ("%%%%attr(%s,root,root) %s\n", $2, $6); }
$1 == "l" { print "%attr(0777,root,root)", $3; }' > files.rpm

set -x

#
%files -f files.rpm

%pre
exit 0

%preun
if [ "$1" -eq 0 ]
then
    #
    # Stop daemons before erasing the package
    #
    if [ -f /etc/pcp.env ] ; then
	. /etc/pcp.env
	$PCP_RC_DIR/pcp stop >/dev/null 2>&1
	$PCP_RC_DIR/pmie stop >/dev/null 2>&1
	[ -x $PCP_RC_DIR/pmproxy ] && PCP_RC_DIR/pmproxy stop >/dev/null 2>&1
	rm -f $PCP_VAR_DIR/pmns/.NeedRebuild
    else
	PCP_WHICH_PROG=type
    fi

    if $PCP_WHICH_PROG chkconfig >/dev/null 2>&1
    then
	chkconfig --del pcp >/dev/null 2>&1
	chkconfig --del pmie >/dev/null 2>&1
	chkconfig --del pmproxy >/dev/null 2>&1
    else
	rm -f /etc/rc.d/rc?.d/S*pcp >/dev/null 2>&1
	rm -f /etc/rc.d/rc?.d/K*pcp >/dev/null 2>&1
	rm -f /etc/rc.d/rc?.d/S*pmie >/dev/null 2>&1
	rm -f /etc/rc.d/rc?.d/K*pmie >/dev/null 2>&1
	rm -f /etc/rc.d/rc?.d/S*pmproxy >/dev/null 2>&1
	rm -f /etc/rc.d/rc?.d/K*pmproxy >/dev/null 2>&1
    fi
fi
exit 0

%postun
exit 0

%post
if [ -f /etc/pcp.env ] ; then
    . /etc/pcp.env
    . $PCP_SHARE_DIR/lib/rc-proc.sh
    touch $PCP_VAR_DIR/pmns/.NeedRebuild
    chmod 644 $PCP_VAR_DIR/pmns/.NeedRebuild

    if [ ! -f $PCP_VAR_DIR/pmns/root ]
    then
    	if [ -f $PCP_VAR_DIR/pmns/root.saved ]
	then
	    # restore the previous pmns after upgrade
	    mv $PCP_VAR_DIR/pmns/root.saved $PCP_VAR_DIR/pmns/root
	else
	    # empty initial name space (prior to Rebuild)
	    echo "root {" >$PCP_VAR_DIR/pmns/root
	    echo "}" >>$PCP_VAR_DIR/pmns/root
	fi
	chmod 644 $PCP_VAR_DIR/pmns/root
    else
    	# root pmns already exists, so we need to restore
	# pmcd.conf and pmcd.options if they were saved.
	for f in $PCP_PMCDCONF_PATH $PCP_PMCDOPTIONS_PATH
	do
	    if [ -f $f -a -f $f.rpmsave ]
	    then
		mv $f $f.rpmnew
		mv $f.rpmsave $f
	    fi
	done
    fi

    if $PCP_WHICH_PROG chkconfig >/dev/null 2>&1
    then
	chkconfig --add pcp >/dev/null 2>&1
	chkconfig --add pmie >/dev/null 2>&1
	chkconfig --add pmproxy >/dev/null 2>&1
    fi

    # pcp (pmcd and pmlogger) is on by default
    # pmie is off by default
    # pmproxy is off by default
    chkconfig_on pcp >/dev/null 2>&1
    chkconfig_off pmie >/dev/null 2>&1
    chkconfig_off pmproxy >/dev/null 2>&1

    #
    # delete *.rpmorig turds that are the same as their new version
    find $PCP_VAR_DIR/config -name \*.rpmorig -print \
    | while read f
    do
    	if diff $f `basename $f .rpmorig` >/dev/null 2>&1
	then
	    rm -f $f
	fi
    done

    x=$PCP_SHARE_DIR/lib/.migrate_pcp_var_dir
    [ -x $x ] && $x
fi
exit 0

%triggerpostun -- pcp < 2.1.9
#
# Fix for bug where pcp-2.1.6 %postun script would chkconfig pcp off
# and remove the .NeedRebuild and .NeedUpdate files. This was done
# *after* the %post script of the new version, causing upgrade havoc.
#
if [ "$1" -gt 0 ]
then
    . /etc/pcp.env
    . $PCP_SHARE_DIR/lib/rc-proc.sh
    touch $PCP_VAR_DIR/pmns/.NeedRebuild
    chmod 644 $PCP_VAR_DIR/pmns/.NeedRebuild

    if which chkconfig >/dev/null 2>&1
    then
	chkconfig --add pcp >/dev/null 2>&1
	chkconfig --add pmie >/dev/null 2>&1
    fi

    # pcp (pmcd and pmlogger) is on by default
    # pmie is off by default
    chkconfig_on pcp >/dev/null 2>&1
    chkconfig_off pmie >/dev/null 2>&1
fi
exit 0

%triggerun -- pcp < 2.2.0-18
#
# first half of fix for bug #825229 where upgrade
# clobbers $PCP_VAR_DIR/pmns/root
#
if [ "$1" -gt 0 ]
then
    . /etc/pcp.env
    if [ -f $PCP_VAR_DIR/pmns/root ]
    then
	cp $PCP_VAR_DIR/pmns/root $PCP_VAR_DIR/pmns/root.saved 
    fi
fi
exit 0

%triggerpostun -- pcp < 2.2.0-18
#
# second half of the fix for bug #825229
#
if [ "$1" -gt 0 ]
then
    . /etc/pcp.env
    if [ ! -f $PCP_VAR_DIR/pmns/root ]
    then
	if [ -f $PCP_VAR_DIR/pmns/root.saved ]
	then
	    mv $PCP_VAR_DIR/pmns/root.saved $PCP_VAR_DIR/pmns/root
	else
	    # empty initial name space (prior to Rebuild)
	    echo "root {" >$PCP_VAR_DIR/pmns/root
	    echo "}" >>$PCP_VAR_DIR/pmns/root
	fi
	chmod 644 $PCP_VAR_DIR/pmns/root
    fi
fi
exit 0
